
-- gb_12a.sql
-- original

set autotrace off echo off

col c1 format a10
col c2 format a10
col c1_cubed format a10
col c2_cubed format a10
col vector format a2

select 'ROW# ' || rownum c1, null c2
from dual
connect by level <= 2

l

/

   
with rowgen as (
   select 'ROW# ' || rownum c1, null c2
   from dual
   connect by level <= 2
)
select
   decode(grouping(c1),1,'SA NULL',nvl(c1,'DATA NULL')) c1
   , decode(grouping(c2),1,'SA NULL',nvl(c2,'DATA NULL')) c2 
from rowgen
group by cube(c1,c2) 
order by 1

l

/


with rowgen as (
   select 'ROW# ' || rownum c1, null c2
   from dual
   connect by level <= 2
)
select
   c1,c2
   , decode(grouping(c1),1,'SA NULL',nvl(c1,'DATA NULL')) c1_cubed
   , decode(grouping(c2),1,'SA NULL',nvl(c2,'DATA NULL')) c2_cubed
   , grouping(c1) || grouping(c2) vector
   , grouping_id(c1,c2) gid
from rowgen
group by cube(c1,c2)  -- c1,c2 correspond to bit 1 and bit 0 in a bit vector
order by gid

l

/


