with cb as (
	select 'Freedonia' country, 'Teasdale' Region, 1 val
	from dual
	union all
	select 'Sylvania' country, 'Chicolini' Region, 1 val
	from dual
)
select country, region, sum(val) val, group_id()
from cb
group by grouping sets((country,region), (country,region))
having group_id() < 1
/
