@@sbase
select distinct
	grouping_id(country,region,district) gid
	, decode ( grouping_id(country, region,district), 2, 'ALL', country) country
	, decode ( grouping_id(country, region,district), 1, 'ALL', region) region
	, decode ( grouping_id(country, region,district), 1, 'ALL', district) district
	, sum(sales)
from rowgen
group by grouping sets (
	rollup(country, region,district)
	,country, region
)
order by 1,2
/
