with rowgen as (
	select 
		case mod(level,3)
			when 0 then 'Australia'
			when 1 then 'Canada'
			when 2 then 'England'
			else 'UNKNOWN'
		end country,
		case mod(level,4) 
			when 0 then 'NE'
			when 1 then 'SE'
			when 2 then 'SW'
			when 3 then 'NW'
			else 'UNKNOWN'
		end region,
		case mod(level,3) 
			when 0 then 'School'
			when 1 then 'Fire'
			when 2 then 'Police'
			else 'UNKNOWN'
		end district ,	
		1 sales
	from dual connect by level <= 100
)